Loading...
Searching...
No Matches
casacore::ArrayLattice< T > Class Template Reference
lattices package (libcasa_lattices) » Lattices_module

More...

`#include <ArrayLattice.h>`

## Public Member Functions

| ArrayLattice ()
| The default constructor creates a ArrayLattice that is useless for just about everything, except that it can be assigned to with the assignment operator.
| ArrayLattice (const IPosition &shape)
| Construct an ArrayLattice with the specified shape.
| ArrayLattice (Array< T > &array, Bool isWritable=True)
| Construct an ArrayLattice that references the given Array.
| ArrayLattice (const Array< T > &array)
| Construct an ArrayLattice that references the given Array.
| ArrayLattice (const ArrayLattice< T > &other)
| The copy constructor uses reference semantics.
virtual | ~ArrayLattice ()
ArrayLattice< T > & | operator= (const ArrayLattice< T > &other)
| The assignment operator uses copy semantics.
virtual Lattice< T > * | clone () const
| Make a copy of the object (reference semantics).
virtual Bool | canReferenceArray () const
| The lattice data can be referenced as an array section.
virtual Bool | isWritable () const
| Is the lattice writable?
virtual IPosition | shape () const
| returns the shape of the ArrayLattice.
virtual void | set (const T &value)
| Set all of the elements in the Lattice to a value.
Array< T > & | asArray ()
| Return the Array of the data within this Lattice.
const Array< T > & | asArray () const
virtual T | getAt (const IPosition &where) const
| Return the value of the single element located at the argument IPosition.
virtual void | putAt (const T &value, const IPosition &where)
| Put the value of a single element.
virtual Bool | ok () const
| Check for internal consistency.
virtual uInt | advisedMaxPixels () const
| Returns the maximum recommended number of pixels for a cursor.
void | getIterSlice (Array< T > &buffer, const IPosition &start, const IPosition &end, const IPosition &incr)
| Get a slice in an optimized way (specifically for ArrLatticeIter).
Public Member Functions inherited from casacore::Lattice< T >
virtual | ~Lattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual DataType | dataType () const
| Get the data type of the lattice.
T | operator() (const IPosition &where) const
| Return the value of the single element located at the argument IPosition.
Bool | get (COWPtr< Array< T > > &buffer, Bool removeDegenerateAxes=False) const
| Functions which extract an Array of values from a Lattice.
Bool | getSlice (COWPtr< Array< T > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
Bool | getSlice (COWPtr< Array< T > > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Bool | getSlice (COWPtr< Array< T > > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Bool | get (Array< T > &buffer, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const Slicer &section, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False)
Array< T > | get (Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const Slicer &section, Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
void | putSlice (const Array< T > &sourceBuffer, const IPosition &where, const IPosition &stride)
| A function which places an Array of values within this instance of the Lattice at the location specified by the IPosition "where", incrementing by "stride".
void | putSlice (const Array< T > &sourceBuffer, const IPosition &where)
void | put (const Array< T > &sourceBuffer)
virtual void | apply (T(*function)(T))
| Replace every element, x, of the Lattice with the result of f(x).
virtual void | apply (T(*function)(const T &))
virtual void | apply (const Functional< T, T > &function)
void | operator+= (const Lattice< T > &other)
| Add, subtract, multiple, or divide by another Lattice.
void | operator-= (const Lattice< T > &other)
void | operator*= (const Lattice< T > &other)
void | operator/= (const Lattice< T > &other)
virtual void | copyData (const Lattice< T > &from)
| Copy the data from the given lattice to this one.
virtual void | copyDataTo (Lattice< T > &to) const
| Copy the data from this lattice to the given lattice.
virtual LatticeIterInterface< T > * | makeIter (const LatticeNavigator &navigator, Bool useRef) const
| These functions are used by the LatticeIterator class to generate an iterator of the correct type for a specified Lattice.
Public Member Functions inherited from casacore::LatticeBase
virtual | ~LatticeBase ()
| A virtual destructor is needed so that it will use the actual destructor in the derived class.
virtual String | imageType () const
| Get the image type (returns name of derived class).
virtual Bool | isPersistent () const
| Is the lattice persistent and can it be loaded by other processes as well?
virtual Bool | isPaged () const
| Is the lattice paged to disk?
virtual void | save (const String &fileName) const
| Save the image in an AipsIO file with the given name.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| It is strongly recommended to use class LatticeLocker to handle lattice locking.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
| Resynchronize the Lattice object with the lattice file.
virtual void | flush ()
| Flush the data (but do not unlock).
virtual void | tempClose ()
| Temporarily close the lattice.
virtual void | reopen ()
| Explicitly reopen the temporarily closed lattice.
virtual String | name (Bool stripPath=False) const
| Return the name of the current Lattice object.
virtual uInt | ndim () const
| Return the number of axes in this Lattice.
virtual size_t | nelements () const
| Return the total number of elements in this Lattice.
size_t | size () const
Bool | conform (const LatticeBase &other) const
| Return a value of "True" if this instance of Lattice and 'other' have the same shape, otherwise returns a value of "False".
virtual LELCoordinates | lelCoordinates () const
| Return the coordinates of the lattice.
IPosition | niceCursorShape (uInt maxPixels) const
| Returns a recommended cursor shape for iterating through all the pixels in the Lattice.
IPosition | niceCursorShape () const
virtual IPosition | doNiceCursorShape (uInt maxPixels) const
| The function (in the derived classes) doing the actual work.
virtual uInt | maximumCacheSize () const
| Maximum cache size - not necessarily all used.
virtual void | setMaximumCacheSize (uInt howManyPixels)
| Set the maximum (allowed) cache size as indicated.
virtual void | setCacheSizeInTiles (uInt howManyTiles)
| Set the actual cache size for this Array to be big enough for the indicated number of tiles.
virtual void | setCacheSizeFromPath (const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath)
| Set the cache size as to "fit" the indicated path.
virtual void | clearCache ()
| Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.
virtual void | showCacheStatistics (ostream &os) const
| Report on cache success.

## Protected Member Functions

virtual Bool | doGetSlice (Array< T > &buffer, const Slicer &section)
| Do the actual getting of an array of values.
virtual void | doPutSlice (const Array< T > &sourceBuffer, const IPosition &where, const IPosition &stride)
| Do the actual putting of an array of values.
Protected Member Functions inherited from casacore::Lattice< T >
| Lattice ()
| Define default constructor to satisfy compiler.
virtual void | handleMath (const Lattice< T > &from, int oper)
| Handle the Math operators (+=, -=, *=, /=).
virtual void | handleMathTo (Lattice< T > &to, int oper) const
| Lattice (const Lattice< T > &)
| Copy constructor and assignment can only be used by derived classes.
Lattice< T > & | operator= (const Lattice< T > &)
void | handleMathTo (Lattice< Bool > &, int) const
Protected Member Functions inherited from casacore::LatticeBase
| LatticeBase ()
| Define default constructor to be used by derived classes.
| LatticeBase (const LatticeBase &)
| Copy constructor and assignment can only be used by derived classes.
LatticeBase & | operator= (const LatticeBase &)
void | throwBoolMath () const
| Throw an exception for arithmetic on a Bool Lattice.

## Private Attributes

Array< T > | itsData
Bool | itsWritable

## Detailed Description

template<class T>
class casacore::ArrayLattice< T >

A memory resident Lattice

### Intended use:

Public interface

### Review Status

Reviewed By:
  Peter Barnes
Date Reviewed:
  1999/10/30
Test programs:
  tArrayLattice

### Prerequisite

- Lattice
- Array

### Etymology

The ArrayLattice name reflects its role as a Lattice interface to an Array object.

### Synopsis

An ArrayLattice is a concrete Lattice class where the data is stored in memory as opposed to the PagedArray class where the data is stored on disk. As a result this class is much more suitable to problems which require small Lattices that can fit into the memory of a computer.

ArrayLattice imposes another layer of function calls on top of a an Array. As a result they should not be used for generic Array manipulation. They are useful if you have an Array that needs to use Lattice functions or needs to be used with PagedArrays or other Lattice derivatives (like LatticeExpr or SubLattice). For example the LatticeIterator class can iterate through an Array in more ways than any of the ArrayIterator classes can. The examples below illustrate some uses for ArrayLattices.

### Example

All the examples in this section are available in dArrayLattice.cc

#### Example 1:

In this example an Array of data is converted into an ArrayLattice so that the copyData function can be used to write the data to a PagedArray which will be stored on disk.

// make an Array and fill it with data.
Array<Float> myArray(IPosition(3, 64, 64, 2));
indgen(myArray); // fills the Array with 0,1,2,....,64*64*2-1
// construct the ArrayLattice
ArrayLattice<Float> myLattice(myArray);
// make a PagedArray to store the data on disk
PagedArray<Float> myPagedArray(myLattice.shape(), "myTestData.array");
// now copy the data onto disk
myPagedArray.copyData (myLattice);
casacore::ArrayLattice::ArrayLattice
ArrayLattice()
The default constructor creates a ArrayLattice that is useless for just about everything,...
casacore::Array
Definition Array.h:155
casacore::IPosition
Definition IPosition.h:117
casacore::PagedArray
Definition PagedArray.h:372
casacore::indgen
void indgen(TableVector< T > &tv, T start, T inc)
Definition TabVecMath.h:398

Note that it could be done in a somewhat simpler way as:

// make an Array and fill it with data.
Array<Float> myArray(IPosition(3, 64, 64, 2));
indgen(myArray); // fills the Array with 0,1,2,....,64*64*2-1
// make a PagedArray to store the data on disk
PagedArray<Float> myPagedArray(myLattice.shape(), "myTestData.array");
// now put the data onto disk
myPagedArray.put (myArray);

#### Example 2:

The ArrayIterator class (or its derivatives the VectorIterator and the MatrixIterator classes) do not allow the user to specify a cursor shape. In this example a Cube class will be converted into an ArrayLattice so that an ArrLatticeIter can be used to access the data spectrum by spectrum (assuming the z-axis is frequency).

Cube<Float> arr(64,64,128);
// assume that the data gets put into the cube somehow
// now construct an ArrayLattice from this cube.
ArrayLattice<Float> lat(arr);
// Construct an iterator that returns the 128-element spectra one at a time
ArrLatticeIter<Float> iter(lat, IPosition(3,1,1,128));
// construct a Matrix to hold the results
Matrix<Float> channelSum(64,64);
// and do the summation one spectrum at a time
for (iter.reset(); !iter.atEnd(); iter++)
channelSum(iter.position().getFirst(2)) = sum(iter.cursor());
casacore::Cube
Definition Cube.h:72
casacore::Matrix
Definition Matrix.h:87
casacore::sum
LatticeExprNode sum(const LatticeExprNode &expr)

There are more examples in the Lattice class and many of the examples in the PagedArray class will also be instructive.

### Motivation

We needed a way of creating Lattices but with Casacore Array characteristics.

Definition at line 143 of file ArrayLattice.h.

## Constructor & Destructor Documentation

## ArrayLattice() [1/5]

template<class T>

casacore::ArrayLattice< T >::ArrayLattice | ( |  | ) |

The default constructor creates a ArrayLattice that is useless for just about everything, except that it can be assigned to with the assignment operator.

Referenced by ArrayLattice(), and operator=().

## ArrayLattice() [2/5]

template<class T>

casacore::ArrayLattice< T >::ArrayLattice | ( | const IPosition & | shape | ) |

explicit

Construct an ArrayLattice with the specified shape.

It results in a writable lattice.

References shape().

## ArrayLattice() [3/5]

template<class T>

casacore::ArrayLattice< T >::ArrayLattice | ( | Array< T > & | array,
|  | Bool | isWritable = True )

Construct an ArrayLattice that references the given Array.

By default it results in a writable lattice.

References casacore::array, isWritable(), and casacore::True.

## ArrayLattice() [4/5]

template<class T>

casacore::ArrayLattice< T >::ArrayLattice | ( | const Array< T > & | array | ) |

Construct an ArrayLattice that references the given Array.

It results in a non-writable lattice.

References casacore::array.

## ArrayLattice() [5/5]

template<class T>

casacore::ArrayLattice< T >::ArrayLattice | ( | const ArrayLattice< T > & | other | ) |

The copy constructor uses reference semantics.

References ArrayLattice().

## ~ArrayLattice()

template<class T>

virtual casacore::ArrayLattice< T >::~ArrayLattice | ( |  | ) |

virtual

## Member Function Documentation

## advisedMaxPixels()

template<class T>

virtual uInt casacore::ArrayLattice< T >::advisedMaxPixels | ( |  | ) | const

virtual

Returns the maximum recommended number of pixels for a cursor.

For this class this is equal to the number of pixels in the lattice.

Reimplemented from casacore::Lattice< T >.

## asArray() [1/2]

template<class T>

Array< T > & casacore::ArrayLattice< T >::asArray | ( |  | ) |

Return the Array of the data within this Lattice.

## asArray() [2/2]

template<class T>

const Array< T > & casacore::ArrayLattice< T >::asArray | ( |  | ) | const

## canReferenceArray()

template<class T>

virtual Bool casacore::ArrayLattice< T >::canReferenceArray | ( |  | ) | const

virtual

The lattice data can be referenced as an array section.

Reimplemented from casacore::LatticeBase.

## clone()

template<class T>

virtual Lattice< T > * casacore::ArrayLattice< T >::clone | ( |  | ) | const

virtual

Make a copy of the object (reference semantics).

Implements casacore::Lattice< T >.

References casacore::Lattice< T >::Lattice().

## doGetSlice()

template<class T>

virtual Bool casacore::ArrayLattice< T >::doGetSlice | ( | Array< T > & | buffer,
|  | const Slicer & | section )

protected virtual

Do the actual getting of an array of values.

Implements casacore::Lattice< T >.

## doPutSlice()

template<class T>

virtual void casacore::ArrayLattice< T >::doPutSlice | ( | const Array< T > & | sourceBuffer,
|  | const IPosition & | where,
|  | const IPosition & | stride )

protected virtual

Do the actual putting of an array of values.

Implements casacore::Lattice< T >.

## getAt()

template<class T>

virtual T casacore::ArrayLattice< T >::getAt | ( | const IPosition & | where | ) | const

virtual

Return the value of the single element located at the argument IPosition.

Note that operator() (defined in the base class) can also be used.

Reimplemented from casacore::Lattice< T >.

## getIterSlice()

template<class T>

void casacore::ArrayLattice< T >::getIterSlice | ( | Array< T > & | buffer,
|  | const IPosition & | start,
|  | const IPosition & | end,
|  | const IPosition & | incr )

Get a slice in an optimized way (specifically for ArrLatticeIter).

It returns in buffer a reference to the lattice array.

## isWritable()

template<class T>

virtual Bool casacore::ArrayLattice< T >::isWritable | ( |  | ) | const

virtual

Is the lattice writable?

Reimplemented from casacore::LatticeBase.

Referenced by ArrayLattice().

## ok()

template<class T>

virtual Bool casacore::ArrayLattice< T >::ok | ( |  | ) | const

virtual

Check for internal consistency.

Returns False if something nasty has happened to the ArrayLattice.

Reimplemented from casacore::LatticeBase.

## operator=()

template<class T>

ArrayLattice< T > & casacore::ArrayLattice< T >::operator= | ( | const ArrayLattice< T > & | other | ) |

The assignment operator uses copy semantics.

References ArrayLattice().

## putAt()

template<class T>

virtual void casacore::ArrayLattice< T >::putAt | ( | const T & | value,
|  | const IPosition & | where )

virtual

Put the value of a single element.

Reimplemented from casacore::Lattice< T >.

References casacore::NewDelAllocator< T >::value.

## set()

template<class T>

virtual void casacore::ArrayLattice< T >::set | ( | const T & | value | ) |

virtual

Set all of the elements in the Lattice to a value.

Reimplemented from casacore::Lattice< T >.

References casacore::NewDelAllocator< T >::value.

## shape()

template<class T>

virtual IPosition casacore::ArrayLattice< T >::shape | ( |  | ) | const

virtual

returns the shape of the ArrayLattice.

Implements casacore::LatticeBase.

Referenced by ArrayLattice().

## Member Data Documentation

## itsData

template<class T>

Array<T> casacore::ArrayLattice< T >::itsData

private

Definition at line 227 of file ArrayLattice.h.

## itsWritable

template<class T>

Bool casacore::ArrayLattice< T >::itsWritable

private

Definition at line 228 of file ArrayLattice.h.

The documentation for this class was generated from the following file:

- lattices/Lattices/ArrayLattice.h